/*
  Copyright (c) 2009, Matyas Bene <notabenem@hotmail.com>
  All rights reserved.

  Redistribution and use in source and binary forms, with or without
  modification, are permitted provided that the following conditions are met:

  - Redistributions of source code must retain the above copyright notice,
    this list of conditions and the following disclaimer. 
  - Redistributions in binary form must reproduce the above copyright notice,
    this list of conditions and the following disclaimer in the documentation
    and/or other materials provided with the distribution.
  - Neither the name of ReichlSoft nor the names of its contributors may be
    used to endorse or promote products derived from this software without
    specific prior written permission.

  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
  AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
  ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
  LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
  CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
  SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
  INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
  CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
  POSSIBILITY OF SUCH DAMAGE.
*/

#ifndef ___DB_BACKUP_PLUGIN_H___
#define ___DB_BACKUP_PLUGIN_H___

//#define COMPILE_DLL_EX
#include "DB_Backup_Settings.h"
#include <string>
typedef std::basic_string<TCHAR> std_string;

// new style init
KP_EXPORT HRESULT KP_API KP_I_INITIALIZELIB_DECL(IKpUnknown* pAPI);
KP_EXPORT HRESULT KP_API KP_I_RELEASELIB_DECL(IKpUnknown* pAPI);
KP_EXPORT HRESULT KP_API KP_I_CREATEINSTANCE_DECL(REFIID riid, void** ppvObject,
   IKpUnknown* pAPI);


class CDB_BackupImpl : public IKpPlugin
{
public:
   CDB_BackupImpl();
   KP_DECL_IUNKNOWN;

   STDMETHODIMP_(BOOL) OnMessage(DWORD dwCode, LPARAM lParamW, LPARAM lParamL);
   STDMETHODIMP_(LPCTSTR) GetProperty(LPCTSTR lpName);
   STDMETHODIMP SetProperty(LPCTSTR lpName, LPCTSTR lpValue);
   STDMETHODIMP_(DWORD) GetMenuItemCount();
   STDMETHODIMP_(KP_MENU_ITEM*) GetMenuItems();

private:
   KP_DECL_STDREFIMPL;
};

void My_ProcessDirectCall(LPARAM lParamW, LPARAM lParamL);
void BackupDB(BOOL bManualSave, LPCTSTR lptDBPath, LPCTSTR lptBackupPrefix);
void DoHouseKeeping(int iNumOfBackups, const TCHAR *tcNewFileName);
std_string GetNextDestination(IKpConfig *pCfg, BOOL bReset);
void InitConfig(void);
#endif
